whoa = {}
cfg = {}

function whoaSetDefaults()
	if (cfg.smallAuraSize == nil) then cfg.smallAuraSize = 20; end
	if (cfg.largeAuraSize == nil) then cfg.largeAuraSize = 25; end
	if (cfg.classColor == nil) then cfg.classColor = true; end
	if (cfg.reactionColor == nil) then cfg.reactionColor = true; end
	if (cfg.BlizzardReactionColor == nil) then cfg.BlizzardReactionColor = false; end
	if (cfg.comboPointFrame == nil) then cfg.comboPointFrame = false; end
	if (cfg.threatNumericIndicator == nil) then cfg.threatNumericIndicator = false;	end
	if (cfg.usePartyFrames == nil) then cfg.usePartyFrames = true; end
	if (cfg.showPartyPets == nil) then cfg.showPartyPets = false; end
	if (cfg.bigAuras == nil) then cfg.bigAuras = true; end
	if (cfg.useBossFrames == nil) then cfg.useBossFrames = true; end
	if (cfg.whoaTexture == nil) then cfg.whoaTexture = true; end
	if (cfg.noClickFrame == nil) then cfg.noClickFrame = false;	end
end
whoaSetDefaults();

-- CreateFont --
function whoa:CreateFont(frame, name, text, x, y, font, size )
	if size == nil then size = 15 end
	if font == nil then font = STANDARD_TEXT_FONT end
local fontString = frame:CreateFontString(name) fontString:SetPoint("TOPLEFT", x, y) fontString:SetFont(font, size, "") fontString:SetText(text)
return (fontString)
end

--	Checkbutton factory.
local uniquealyzer = 1;
function createCheckbutton(parent, x_loc, y_loc, displayname)
	uniquealyzer = uniquealyzer + 1;
	local checkbutton = CreateFrame("CheckButton", "whoaCheckButton" .. uniquealyzer, parent, "ChatConfigCheckButtonTemplate");
	checkbutton:SetPoint("TOPLEFT", x_loc, y_loc);
	getglobal(checkbutton:GetName() .. 'Text'):SetText(displayname);
	return checkbutton;
end

-- CreateButton --
function whoa:CreateButton(frame, name, text, width, height, x, y, template)
if (template == nil) then template = "OptionsButtonTemplate"
end
local button = CreateFrame("Button", name, frame, template) button:SetPoint("TOPLEFT", x, y) button:SetWidth(width)
button:SetHeight(height) button:SetText(text)
return (button)
end

--	UI panel
function whoa:CreateUI(frame)
	
	--	UI panel.
	whoaUI = {}
	whoaUI.panel = CreateFrame( "Frame", "whoaUI", UIParent );
	whoaUI.panel.name = "whoa UnitFrames";
	InterfaceOptions_AddCategory(whoaUI.panel);

	local title = whoa:CreateFont(whoaUI.panel, "title", "whoa UnitFrames v9.1", 15, -18, font, 15)
	title:SetFontObject(GameFontNormal) 
	title:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	local disclaimer = whoa:CreateFont(whoaUI.panel, "disclaimer", "Work in progress! At the moment is required a reload (/rl) for correct aplication of changes.", 15, -40, font, 12)
	disclaimer:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)

	local xOffset = -80;
	
	--	Class colored HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset, "Class Color HP.");
	myCheckButton.tooltip = "Displays class colored HP bars on player frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton2:GetChecked() then
			cfg.classColor = true;
		else
			cfg.classColor = false;
		end
	end );

	--	Unit reaction color HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-30, "Reaction colored HP bars.");
	myCheckButton.tooltip = "Display unit´s reaction colored HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton3:GetChecked() then
			cfg.reactionColor = true;
		else
			cfg.reactionColor = false;
			cfg.BlizzardReactionColor = false;
			whoaCheckButton4:SetChecked(false);
		end
	end );
	
	--	Unit bright reaction color HP.
	myCheckButton = createCheckbutton(whoaUI.panel, 280, xOffset-30, " Bright reaction colors.");
	myCheckButton.tooltip = "Displays bright reaction colors on non-player enemies HP bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
	
		if whoaCheckButton4:GetChecked() then
			cfg.reactionColor = true;
			cfg.BlizzardReactionColor = true;
			whoaCheckButton3:SetChecked(true);
			whoaAuraResize()
		else
			cfg.BlizzardReactionColor = false;
			whoaCheckButton4:SetChecked(false);
			whoaAuraResize()
		end
	end );
		
	--	Aura size.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-60, "Enlarge auras.");
	myCheckButton.tooltip = "Displays bigger debuffs on enemy frames and buffs on allied frames to 4 in a row.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton5:GetChecked() then
			cfg.largeAuraSize = 27			--	max row width is 122. This is 4 buffs in a row.
			cfg.smallAuraSize = 21
			cfg.bigAuras = true;
		else
			cfg.largeAuraSize = 21			--	default size. This is 5 in a row.
			cfg.smallAuraSize = 17
			cfg.bigAuras = false;
		end
	end );
	
	--	whoa Party frames.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-90, "whoa´s party frame style.");
	myCheckButton.tooltip = "Use whoa´s party frames style when not using Compact Raid Frames. Works for whoa´s and Blizzard´s default frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton6:GetChecked() then
			cfg.usePartyFrames = true;
		else
			cfg.usePartyFrames = false;
		end
	end );
	
	--	whoa hp texture.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-120, "whoa´s Legacy status texture.");
	myCheckButton.tooltip = "Use whoa´s legacy texture on status bars.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton7:GetChecked() then
			cfg.whoaTexture = true;
		else
			cfg.whoaTexture = false;
		end
	end );
	
	local fancyOptions = whoa:CreateFont(whoaUI.panel, "fancyOptions", "Other fancy options.", 15, xOffset-160, font, 12)
	fancyOptions:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	--	Combo points in frame.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-190, "Legacy combo points on target frame.");
	myCheckButton.tooltip = "Re-enables Wow´s old default combo point bar on target frame. Does not hides player frame´s combo points or personal resource bar (Rogues and druids only).";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton8:GetChecked() then
			SetCVar("comboPointLocation",1)
			cfg.comboPointFrame = true;
		else
			SetCVar("comboPointLocation",2)
			cfg.comboPointFrame = false;
		end
	end );
		
	--	Old threat numeric indicator.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-220, "Legacy threat numeric indicator.");
	myCheckButton.tooltip = "Re-enables Wow´s old default threat numeric indicator which shows current´s target threat over ";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton9:GetChecked() then
			SetCVar("threatShowNumeric",1)
			cfg.threatNumericIndicator = true;
		else
			SetCVar("threatShowNumeric",0)
			cfg.threatNumericIndicator = false;
		end
	end );

	
	--	Show pets on party frames.
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-250, "Show pets on party frames.");
	myCheckButton.tooltip = "Show pets on party frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton10:GetChecked() then
			SetCVar("showPartyPets",1)
			cfg.showPartyPets = true;
		else
			SetCVar("showPartyPets",0)
			cfg.showPartyPets = false;
		end
	end );
	
	--	Unclikeable frames
	myCheckButton = createCheckbutton(whoaUI.panel, 40, xOffset-370, "Disable mouse clicks over player and target frames.");
	-- myCheckButton:SetEnabled(false);
	myCheckButton.tooltip = "Disable mouse clicks over player and target frames.";
	myCheckButton:SetScript("OnClick",
	function(self)
		if whoaCheckButton11:GetChecked() then
			cfg.noClickFrame = true;
		else
			cfg.noClickFrame = false;
		end
		whoaNoClick()
	end );
	
		--	Positioning
	local positionOptions = whoa:CreateFont(whoaUI.panel, "mainOptions", "Positioning options.", 25, xOffset-350, font, 13)
	mainOptions:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	local centerBttnInfo = whoa:CreateFont(whoaUI.panel, "centerBttnInfo", "Center player and target frames middle screen.", 50, -500, font, 12)
	mainOptions:SetPoint("LEFT",whoaUI.panel,"TOPLEFT",0,0)
	
	local centerBttn = CreateFrame("Button", "centerButton", whoaUI.panel, "UIPanelButtonTemplate")
	centerBttn:SetSize(110 ,25)
	centerBttn:SetText("Center frames")
	centerBttn:SetPoint("BOTTOMLEFT",70,20)
	centerBttn:SetScript("OnClick", function()
		local x,y = -20,-150 for i,f in pairs({PlayerFrame,TargetFrame}) do f:ClearAllPoints() f:SetPoint(i==1 and "RIGHT" or "LEFT",UIParent,"CENTER",i==1 and x or -x,y) f:SetUserPlaced(true) end
	end)
	
	local resetBttn = CreateFrame("Button", "resetButton", whoaUI.panel, "UIPanelButtonTemplate")
	resetBttn:SetSize(100 ,25)
	resetBttn:SetText("Reset frames")
	resetBttn:SetPoint("BOTTOMLEFT",210,20)
	resetBttn:SetScript("OnClick", function()
		PlayerFrame_ResetUserPlacedPosition()
		TargetFrame_ResetUserPlacedPosition()
	end)
	
	local reloadBttn = CreateFrame("Button", "reloadButton", whoaUI.panel, "UIPanelButtonTemplate")
		reloadBttn:SetSize(80 ,22)
		reloadBttn:SetText("Reload UI")
		reloadBttn:SetPoint("BOTTOMRIGHT",-20,20)
		reloadBttn:SetScript("OnClick", function()
		ReloadUI()
	end)
end

SlashCmdList.whoaUI = function()
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
	InterfaceOptionsFrame_OpenToCategory(whoaUI.panel)
end

SLASH_whoaUI1 = "/whoaUI"
SLASH_whoaUI1 = "/wuf"
SLASH_whoaUI1 = "/whoa"
SlashCmdList['RELOAD'] = function() ReloadUI() end
LASH_RELOAD1 = '/rl'

whoa:CreateUI()
--	Events
function whoa:Init(event, addon, ...)
	if ( cfg.classColor==true) then whoaCheckButton2:SetChecked(true) end
	if ( cfg.reactionColor == true ) then whoaCheckButton3:SetChecked(true)	end
	if ( cfg.BlizzardReactionColor == true) then whoaCheckButton4:SetChecked(true) end
	if ( cfg.bigAuras == true) then whoaCheckButton5:SetChecked(true) end
	if ( cfg.usePartyFrames == true) then whoaCheckButton6:SetChecked(true)	end	
	if ( cfg.whoaTexture == true) then whoaCheckButton7:SetChecked(true) end
	if ( cfg.comboPointFrame == true) then whoaCheckButton8:SetChecked(true) end
	if ( cfg.threatNumericIndicator == true) then whoaCheckButton9:SetChecked(true) end
	if ( cfg.showPartyPets == true) then whoaCheckButton10:SetChecked(true) end
	-- if ( cfg.useBossFrames == true) then whoaCheckButton9:SetChecked(true) end
	if (cfg.noClickFrame == true) then whoaCheckButton11:SetChecked(true) end
	whoaNoClick()
	if (event == "ADDON_LOADED" and addon == "whoaUnitFrames") then
		print("|cff00ccff [WhoaUnitFrames] v9.1 |cff888888is now loaded. Use |cffffff00'/whoa' |cff888888to view options.")
	end
end
-- create addon frame
local whoaUI = CreateFrame("Frame", "whoaUI", UIParent)
whoaUI:SetScript("OnEvent", whoa.Init)
whoaUI:RegisterEvent("ADDON_LOADED")